use32
        db      'MENUET01'
        dd      1
        dd      start
        dd      i_end
        dd      mem
        dd      mem
        dd      0
        dd      0

REQ_DLL_VER = 2
DLL_ENTRY = 1

start:
; First 3 steps are intended to load/init console DLL
; and are identical for all console programs

; load DLL
        mov     eax, 68
        mov     ebx, 19
        mov     ecx, dll_name
        int     0x40
        test    eax, eax
        jz      exit

; initialize import
        mov	edx, eax
        mov     esi, myimport
import_loop:
        lodsd
        test    eax, eax
        jz      import_done
        push    edx
import_find:
        mov     ebx, [edx]
        test    ebx, ebx
        jz      exit;import_not_found
        push    eax
@@:
        mov     cl, [eax]
        cmp     cl, [ebx]
        jnz     import_find_next
        test    cl, cl
        jz      import_found
        inc     eax
        inc     ebx
        jmp     @b
import_find_next:
        pop     eax
        add     edx, 8
        jmp     import_find
import_found:
        pop     eax
        mov     eax, [edx+4]
        mov     [esi-4], eax
        pop     edx
        jmp     import_loop
import_done:

; check version
        cmp     word [dll_ver], REQ_DLL_VER
        jb      exit
        cmp     word [dll_ver+2], REQ_DLL_VER
        ja      exit
        push    DLL_ENTRY
        call    [dll_start]

; yes! Now do some work
        push    caption
        push    -1
        push    -1
        push    -1
        push    -1
        call    [con_init]
        mov	eax, 40
        mov	ebx, 0x80
        int	0x40
        push    str1
        call    [con_write_asciz]
        mov	eax, 52
        mov	ebx, 18
        xor	edx, edx
        mov	esi, offerbuf
        mov	edi, 4096
        int	0x40
        push	str2
        call	[con_write_asciz]
        mov	eax, 23
        mov     ebx, 500
        int     0x40
        mov     eax, 52
        mov     ebx, 19
        int	0x40
        cmp	dword [offerbuf], 0
        jnz	offers
        push	str3
        call	[con_write_asciz]
        jmp	done
offers:
	push	str4
	call	[con_write_asciz]
	xor	edi, edi
	mov	esi, offerbuf+4+6
	lodsd
	xchg	eax, ecx
@@:
	sub	ecx, 4
	jb	offerdone
	lodsw
	cmp	ax, 0x0201
	jz	found
	lodsw
	xchg	al, ah
	sub	cx, ax
	jae	@b
offerdone:
	push	str5
	call	[con_write_asciz]
	jmp	done
found:
	lodsw
	xchg	al, ah
	movzx	eax, ax
	push	esi
	push	eax
	push	str6
	call	[con_printf]
	add	esp, 12
done:
        push    0
        call    [con_exit]
exit:
        or      eax, -1
        int     0x40

dll_name db '/sys/lib/console.obj',0

align 4
myimport:
dll_start       dd      aStart
dll_ver         dd      aVersion
con_init        dd      aConInit
con_write_asciz dd      aConWriteAsciz
con_printf      dd      aConPrintf
con_exit	dd	aConExit
                dd      0

aStart          db      'START',0
aVersion        db      'version',0
aConInit        db      'con_init',0
aConWriteAsciz  db      'con_write_asciiz',0
aConPrintf      db      'con_printf',0
aConExit        db      'con_exit',0

caption	db	'PPPoE offers test',0
str1	db	'Sending Initiation packet...',10,0
str2	db	'Waiting for response...',10,0
str3	db	'None received.',10,0
str4	db	'Got offer, AC-Name is ',0
str5	db	'[not present]',10,0
str6	db	'%.*s',10,0

i_end:

offerbuf rb 4096

align 4
rb 2048 ; stack
mem:
